﻿namespace CommonUtilityInfrastructure.Tests
{
    using System.Runtime.InteropServices;
    using NUnit.Framework;
    using SoftwareApproach.TestingExtensions;
    using UsefulTools.Core;

    [TestFixture]
    public class ProgressCounterTest
    {


        [Test]
        public void Progress_basic_usage()
        {
            int currentValue = 0;
            var progressCounter = ProgressCounter.Invoking(percentCompleted =>
            {
                currentValue = percentCompleted;
            });

            // Initialize with max value
            progressCounter.Initialize(20);

            currentValue.ShouldEqual(0);

            progressCounter.Progress();
            currentValue.ShouldEqual(5);
        }



        [Test]
         public void Progress_with_subprogress()
         {
             int current = -1;
             var progress = ProgressCounter.Invoking(val =>
                 {
                     current = val;
                 });

             progress.Initialize(10);

             progress.Progress();


             current.ShouldEqual(10);

             var sub = progress.CreateSubprogress();

             sub.Initialize(10);

             sub.Progress();

             current.ShouldEqual(11);

             progress.Progress();

             current.ShouldEqual(20);

             sub.Initialize(5);

             sub.Progress();

             current.ShouldEqual(22);

             sub.Progress();
             sub.Progress();
             sub.Progress();
             sub.Progress();
             current.ShouldEqual(30);

             progress.Progress();

             current.ShouldEqual(30);

             sub.Initialize(1);

             sub.Progress();
             current.ShouldEqual(40);
         }


    }
}