﻿namespace UsefulTools.ExtensionMethods
{
    #region Usings

    using System.Collections.Generic;
    using System.Linq;

    #endregion

    public static class Common
    {
        public static T CastTo<T>(this object obj)
        {
            return (T)obj;
        }
        public static bool IsAnyOf<T>(this object obj)
        {
            return obj is T;
        }
        public static bool IsAnyOf<T1,T2>(this object obj)
        {
            return obj is T1 || obj is T2 ;
        }
        public static bool IsAnyOf<T1, T2, T3>(this object obj)
        {
            return obj is T1 || obj is T2 || obj is T3;
        }
        public static bool IsAnyOf<T1, T2, T3, T4>(this object obj)
        {
            return obj is T1 || obj is T2 || obj is T3 || obj is T4;
        }
        public static bool IsAnyOf<T1, T2, T3, T4, T5>(this object obj)
        {
            return obj is T1 || obj is T2 || obj is T3 || obj is T4 || obj is T5;
        }
        public static bool IsAnyOf<T1, T2, T3, T4, T5, T6>(this object obj)
        {
            return obj is T1 || obj is T2 || obj is T3 || obj is T4 || obj is T5 || obj is T6;
        }
        public static List<T> InList<T>(this T obj) 
        {
            var arr = new List<T>();
            arr.Add(obj);
            return arr;
        }
        public static List<T> InList<T, T2>(this T2 obj) where T2 : T
        {
            var arr = new List<T>();
            arr.Add(obj);
            return arr;
        }
        public static T[] InArrayIf<T>(this T obj, bool condition)
        {
            if(condition)
            {
                var arr = new T[1];
                arr[0] = obj;
                return arr;
            }
            else
            {
                return new T[0];
            }
        }

        public static IEnumerable<T> ToEnumerable<T>(this T obj)
        {
            return obj.InList();
        }


        public static bool IsIn<T>(this T obj, params T[] values)
        {
            return values.Contains(obj);
        }


    }
}