﻿namespace UsefulTools.ExtensionMethods
{
    using System;

    public static class Numbers
    {
        public static int IncrementedIf(this int value, bool condition)
        {
            return condition ? value + 1 : value;
        }
        public static int AsPercentageOf(this int part, int all)
        {
            Throw.If(part < 0 || all < 0 || part > all || all == 0);
            return (int)(((double)part / all) * 100);
        }
        public static int AsPercentageOf(this double part, double all)
        {
            Throw.If(part < 0 || all < 0 || part > all || Math.Abs(all - 0) < 0.0000001);
            return (int)Math.Round((part / all) * 100d);
        }
        public static double RoundToSignificantDigits(this double d, int digits)
        {
            double scale = Math.Pow(10, Math.Floor(Math.Log10(d)) + 1);
            return scale * Math.Round(d / scale, digits);
        }
 
    }
}