﻿namespace UsefulTools.ExtensionMethods
{
    using System.IO;
    using System.Linq;

    public static class Strings
    {
        public static string RemoveInvalidPathCharacters(this string str)
        {
            Throw.IfNull(str);
            return Path.GetInvalidPathChars().Aggregate(str, (current, ch) => current.Replace(ch, '_'));
        }
        public static bool NullOrEmpty(this string str)
        {
            return string.IsNullOrEmpty(str);
        }

        public static string InQuotes(this string str)
        {
            Throw.IfNull(str);
            return string.Format(@"""{0}""", str);
        }
        public static string Formatted(this string str, params object[] args)
        {
            Throw.IfNull(str);
            return string.Format(str, args);
        }
    }
}